<?php
/**
* This file is just a shell for how the payment may work.
* It should be rewritten/replaced with the code needed to performe payments with your payment service, e.g. Payex or similar.
*
* Input to this file: Payment.php?conf=OSS2010REG&regid=a6c361f76d87
*/

include_once("basic.php");
include("dbcredentialspath.php");
include(DB_CREDENTIALS_PATH);
include_once("costFunction.php");

dbConnect();

$_POST = array_map('sanitizeInput', $_POST);
$_GET = array_map('sanitizeInput', $_GET);



// This is the html file header code
//-----------------------------------------------------------

echo "<html>\n";
echo "<meta http-equiv='content-type' content='application/xhtml+xml; charset=UTF-8' />\n";
echo "<link rel='icon' href='Pernilla_Icon_16x16.png' type='image/png' />\n";
echo "<title>";
echo "Pernilla. Conference Registration & Payment System";
echo "</title>\n";
echo "<link rel='stylesheet' type='text/css' href='css/payment.css'/>\n";
echo "</head>\n";
echo "<body>\n";

echo "<div id='wrapper'>";

if(isset($_GET['conf'])){
	$conference=$_GET['conf'];
	if(!isset($_GET['regid'])){
		err("No regid submitted","Error");
	}
	$regid=$_GET['regid'];
	
	//Get info about conference
	$querystring = "SELECT * FROM conferences WHERE confname='".sanitizeInput($conference)."';";
	$result = mysql_query($querystring);
	if(!$result) err("Error when gathering conference information.","Error");
	$row = mysql_fetch_assoc($result);	
	
	echo "<h1>Payment for the registration to <br />".$row['longname']." <br />".date('Y-m-d',strtotime($row['confdate']))."</h1>";
		
	//Get registration data
	$querystring = "SELECT * FROM conf_".sanitizeInput($conference)." WHERE regno='".sanitizeInput($regid)."' ;";
	$result = mysql_query($querystring);
	if(!$result) err("Error when gathering registration information.","Error");
	$regData = mysql_fetch_assoc($result);	
	
	if($regData['state'] == PAID_BY_CARD or $regData['state'] == PAID_BY_INVOICE){
			echo "This registration has already been paid for.";
			exit();
	} else {
		//When a payment is done the database is updated accordingly 
		if(isset($_POST['paid'])){ //THIS IS NOT A SAFE WAY TO HANDLE THIS - only used for testing/demo purposes
			$querystring = "UPDATE conf_".sanitizeInput($conference)." SET state='2' WHERE regno='".sanitizeInput($regid)."';";
			$result = mysql_query($querystring);
			if(!$result) err("Error when updating registration state.","Error");
			echo "<p>Thank you. <br /> Your payment has been registered.</p>";
		} else {		
			//Calculate cost for registration
			$cost = calculateRegistrationCost($regid,$conference,"Default");
			
			$additionalcost = $regData['additionalCost']; //May need to be sent to payment service
			
			//The following two lines is used to check if the cost stored in the database is the same as the one calculated above.
			//This assumes that the calculation has already been done in Register_submit.php, if not these lines needs to be removed
			//or the code won't work, i.e. an error will always be produced.
			$costStoredInDatabase = $regData['cost']; 
			if($cost != $costStoredInDatabase) err("Stored cost not equal to calculated cost.","Error");
			//echo "<p>".$cost." | ".$costStoredInDatabase."</p>"; //DEBUG CODE
			
			$totalAmount = $additionalcost + $cost; //The total amount to pay
			//Check that the total cost is NOT less than zero - extra safety check
			if(($totalAmount) < 0) err("Total amount to pay is less then zero","Error");
			
			echo "<h2>Amount to pay: ".$totalAmount."</h2>";
		
		
			echo "<h4>Please select your prefered way of payment below.</h4>";
			//Send payment info to payment service - This is now done with a simple form. This is usually not the way to do this.
				// Send to payment service: $regid $cost $additionalcost
			echo "<form name='paymentForm' action='PaymentServiceDemo.php' method='post'>";
			echo "<input type='hidden' name='amount' value='".$totalAmount."' />";
			echo "<input type='hidden' name='cost' value='".$cost."' />";
			echo "<input type='hidden' name='additionalcost' value='".$additionalcost."' />";
			echo "<input type='hidden' name='regid' value='".$regid."' />";
			echo "<input type='hidden' name='confname' value='".$conference."' />";
			echo "<input type='hidden' name='payment' />";
			echo "<label for='paymentType'>You will pay your registration with:</label>";
			echo "<select name='paymentType'>";
			echo "<option value='VISA'>VISA</option>";
			echo "<option value='Mastercard'>Mastercard</option>";
			echo "<option value='Invoice'>Invoice</option>";
			echo "</select>";
			echo "<input type='submit' name='pay' value='Confirm' />";
			echo "</form>";
			
		}	
	}	
} else {
	err("No conference submitted","Error");
}

echo "</div>";

echo "</body>\n";
echo "</html>\n";
?>

