<?php

	// +----------------------------------------------------------------------+
	// | PernillaSYS.                                                         |
	// +----------------------------------------------------------------------+
	// | This file is subject to the GNU GPL license                          |
	// +----------------------------------------------------------------------+
	
	require_once('generate.php');
	
	/**
	* Displays the form for the given conference.
	* This function requires an open database connection 
	* and that sessions is started to function properly.
	* Also functions in basic.php is used, e.g. the err() function and the gatherConferences function. 
	*
	* $confname - String, sets the conference for which to display the form
	* $previewMode - Boolean, TRUE = display in preview mode
	*/	
	function showRegistrationForm($confname, $formname, $previewMode){
		//Define numbers to tagnames
		/*define("BOX_HEADING_START",1);
		define("BOX_HEADING_END",2);
		define("TABLE_START",3);
		define("TABLE_END",4);
		define("ROW_START",5);
		define("ROW_END",6);
		define("TEXT_FIELD",7);
		define("SELECT_OPTION_BOX",8);
		define("PLACEHOLDER",9);
		define("RADIO_BUTTON",10);
		define("LOCKED_COMPUTATION_BOX",11);
		define("CHECKBOX",12);
		define("LINE",13);
		define("FOOTNOTE",14);
		define("IMAGE",15);*/
		
		$isLoggedIn=FALSE;
		if($previewMode){
			//Check if logged in 
			if (isset($_SESSION['myusername'])&&isset($_SESSION['mypassword'])){
				$myusername=sanitizeInput(($_SESSION['myusername']));
				$mypassword=sanitizeInput(($_SESSION['mypassword']));
				$querystring="SELECT * FROM personal WHERE persemail=".phpencode($myusername,80)." AND pw=".phpencode($mypassword,80).";";
				$result = mysql_query($querystring);
				if (!$result){	
					err("<p>SQL Query Error: ".mysql_error(),"Database Password Check Error</p>","<h2>Error:</h2>");
				} else {
					if(mysql_num_rows($result) != 0){ //User is logged in
						$isLoggedIn = TRUE;
					} else { //Wrong username and/or password
						err("Incorrect username and/or password was given","<h2>Error</h2>");
					}
				}
				//Check if the user has access to the conference
				$row = mysql_fetch_assoc($result);		
				if($conferences = gatherConferences($row['PID'])){ 
					if(!in_array($confname,$conferences,TRUE)){
						err("<p>You do not have access to this conference. Contact your Pernilla System administrator to get conference access.</p>","<h2>Error:</h2>");	
					}
				} else { //Conference gathering failed
					err("<p>No conferences found for this user. Contact your Pernilla System administrator to get conference access.</p>","<h2>Error:</h2>");
				}
			} else {
				err("<p>The preview feature can only be reached from within the Pernilla System.</p>","<h2>Error:</h2>");	
			}

		}
		
		//Check if conference exists and if its open
		$registrationsOpen = FALSE;
		$querystring = "SELECT * FROM conferences WHERE confname='".sanitizeInput(htmlentities($confname))."';";
		$result = mysql_query($querystring);
		if (!$result){
			err("<p>SQL Query Error: ".mysql_error(),"Error accessing the database. Query used: ".$querystring."</p>","<h2>Error:</h2>");
		} else {
			if(!mysql_num_rows($result)>0){ //True if conference exists
				err("<p>The requested conference doesn't exist. </p>","<h2>Error:</h2>");
			} else {
				//check if registration is open
				$row = mysql_fetch_assoc($result);
				$now = strtotime(date("Y-m-d")); 
				$regstart = strtotime($row['regstart']);
				$regend = strtotime($row['regend']);
				$offlineregend = strtotime($row['offlineregend']);
				$aftertext = $row['aftertext'];
				$beforetext = $row['beforetext'];
				$offlineaftertext = $row['offlineaftertext'];
				$price = $row['price'];
				
				
				//echo $now." ".$regstart." ".$regend." ".$offlineregend."<br>";
				
				if($now<$regstart){	//Reg not open yet				
					echo str_replace("&lt;br&gt;","<br>",$beforetext);
					$registrationsOpen = FALSE;
				} else if($now>$regend and $now<$offlineregend){ //Reg online no longer possible, on site still possible
					echo str_replace("&lt;br&gt;","<br>",$aftertext);
					$registrationsOpen = FALSE;
				} else if($now>$offlineregend){	//No reg is open
					echo str_replace("&lt;br&gt;","<br>",$offlineaftertext);
					$registrationsOpen = FALSE;
				} else { //Reg is open
					$registrationsOpen = TRUE;
				}
				
				//Check if the conference is locked - unlocked conferences should not be accessible in anything but preview mode
				if($row['locked'] != 1){ //not locked
					$registrationsOpen = FALSE;
					$unLocked = TRUE;
				} else {
					$unLocked = FALSE;
				}
				
			}
		}
		
		/* Some debug code - remove if everything seems to work ok
		echo "Preview:".$previewMode."<br />";
		echo "isLoggedIn:".$isLoggedIn."<br />";
		echo "registrationsOpen:".$registrationsOpen." <br />";
		echo "----<br />";*/
		
		if(!($previewMode and $isLoggedIn) and $unLocked){
			err("This conference is still unlocked and may therefore only be accessed in preview mode.","<h2>Error:</h2>");
		}
		
		//Display preview message and create back button
		if($previewMode and $isLoggedIn){
			echo "<form action='index.php' method='post' style='border:1px solid #000;padding:10px;'>";
			echo "<p>This is a preview of the registration form.</p>";
			echo "<input type='submit' name='back' id='backButton' value='Back to form editor' />\n";
			echo "<input type='hidden' name='tabname' value='ManageForms' />";
			echo "<input type='hidden' name='conferencefilter' value=".$confname." />";
			echo "</form>";
		}
		
		//Display form if registration is open or preview mode is entered and user is logged in
		if($registrationsOpen or ($previewMode and $isLoggedIn)){
			//Display form
			echo "<form action='Register_submit.php' method='post'";
			echo " name='".$confname."' ";
			echo ">\n";
			
			echo "<input type='hidden' name='confname' value='".$confname."' />";
			echo "<input type='hidden' name='formname' value='".$formname."' />";
		
			$q = mysql_query('SELECT * FROM formlog WHERE conferenceId="' . sanitizeInput($confname) . '" ORDER BY revision DESC LIMIT 1');
			$formHTML = '';
			
			while ($form = mysql_fetch_array($q))
			{
				$formHTML = doGenerate(htmlspecialchars_decode($form['formHTML']));
			}
			echo $formHTML;
/* 			$querystring="select * from fields where formname='".htmlentities($confname)."' and fieldtype is not null order by fieldsort;";
			$result=mysql_query($querystring);
			if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error".$querystring);
			
			while ($row = mysql_fetch_assoc($result)) {

				if($row['fieldtype'] == BOX_HEADING_START){
					echo "<div style='padding-right:10px;padding-left:10px;padding-top:10px;padding-bottom:10px;border-width:thin; border-style:solid; background:".$row['fieldcolor'].";border-style: outset;'>"; 
					echo "<h2><center>".$row['fieldtext']."</center></h1><hr>";
				}else if($row['fieldtype'] == BOX_HEADING_END){
					echo "</div><br>"; 
				}else if($row['fieldtype'] == TABLE_START){
					echo "<table width='100%' border='0'>"; 
				}else if($row['fieldtype'] == TABLE_END){
					echo "</table>";
				}else if($row['fieldtype'] == ROW_START){
					echo "<tr>";
				}else if($row['fieldtype'] == ROW_END){
					echo "</tr>";
				}else if($row['fieldtype'] == TEXT_FIELD){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."<input type='text' tabindex='".$row['fieldno']."' name='".$row['fieldname']."' id='".$row['fieldname']."' value='".$row['fielddef']."' size='".$row['fieldsize']."' ";
					if($row['fieldverify']==""){
						echo " >\n";
					}else{
						echo " OnKeyUp='";
						echo $row['fieldverify'];
						echo "'>\n";			
					}			
					echo "</td>\n";
				}else if($row['fieldtype'] == SELECT_OPTION_BOX){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."<select name='".$row['fieldname']."' "."id='".$row['fieldname']."' ";
					if($row['fieldverify']==""){
						echo " >\n";
					}else{
						echo " Onchange='";
						echo $row['fieldverify'];
						echo "'>\n";			
					}			
					$result2=mysql_query("select * from options where boxid='".$row['fieldref']."' order by optionno;");
					if (!$result2) err("SQL Query Error: ".mysql_error(),"Database Query Error");
						while ($row = mysql_fetch_assoc($result2)) {
							echo "<option name='".$row['optionname']."'>".$row['optionval']."</option>\n";
						}			
					echo "</select></td>\n";
					mysql_free_result($result2);
				}else if($row['fieldtype'] == PLACEHOLDER){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."\n";
					echo "</td>\n";
				}else if($row['fieldtype'] == RADIO_BUTTON){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']." rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."<input type='radio' name='".$row['fieldref']."' id='".$row['fieldref']."' value='".$row['fielddef']."'";
						
					if($row['fieldverify']==""){
						echo ">\n";
					}else{
						echo " OnClick='";
						echo $row['fieldverify'];
						echo "'>\n";			
					}			
					echo "</td>\n";
				}else if($row['fieldtype'] == LOCKED_COMPUTATION_BOX){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."<input type='text' onfocus='this.blur();' autocomplete='off' value='0' name='".$row['fieldname']."' id='".$row['fieldname']."' value='".$row['fielddef']."' size='".$row['fieldsize']."'>\n";
					echo "</td>\n";
				}else if($row['fieldtype'] == CHECKBOX){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo $row['fieldtext']."<input type='CHECKBOX' name='".$row['fieldname']."' id='".$row['fieldname'];
					if($row['fieldverify']==""){
						echo "'>\n";
					}else{
						echo "' OnClick='";
						echo $row['fieldverify'];
						echo "'>\n";
					}						
						echo "</td>\n";
				}else if($row['fieldtype'] == LINE){
					echo "<td align='".$row['fieldalign']."' width='".$row['fieldwidth']."' colspan='".$row['fieldspan']."' rowspan='".$row['fieldrowspan']."'>\n";
					echo "<hr>\n";
					echo "</td>\n";
				}else if($row['fieldtype'] == FOOTNOTE){
					// Replace &lt;br&gt; with <br> in fieldtext. This way we can still have newLINEs in end message
					echo "<div>".str_replace("&lt;br&gt;","<br>",$row['fieldtext'])."</div>\n";
				}else{
					err("Field Processing Error: Unknown Field Type: ".$row['fieldtype'],"Field Processing Error");
				}
				echo "\n";
			} */
			
			// This is the html file footer code
			//-----------------------------------------------------------
		
			//If in preview mode disable the submit button
			echo "<br /><br /><span class='totalSum' >Total Cost: $price</span><br />";
			if($previewMode){ 
				echo "<input type='submit' id='Submitbutton' value='Submit Registration' disabled='disabled' />\n";
			} else {
				echo "<input type='submit' id='Submitbutton' value='Submit Registration' />\n";
			}
			echo "</form>\n";				
		} else {
			echo "No registation end date set.";
		}
	} //End of function
?>
