<?php
	//Define constants
	
	//Definition of userkind constants
	define("ADMIN",1);
	define("ORGANIZER",2);
	define("CLIENT",3);

	//Definition of fieldtype constants	
	define("BOX_HEADING_START",1);
	define("BOX_HEADING_END",2);
	define("TABLE_START",3);
	define("TABLE_END",4);
	define("ROW_START",5);
	define("ROW_END",6);
	define("TEXT_FIELD",7);
	define("SELECT_OPTION_BOX",8);
	define("PLACEHOLDER",9);
	define("RADIO_BUTTON",10);
	define("LOCKED_COMPUTATION_BOX",11);
	define("CHECKBOX",12);
	define("LINE",13);
	define("FOOTNOTE",14);
	define("IMAGE",15);
	
	//Definition of layouttype constants
	define("BLOCK_START",1);
	define("BLOCK_END",2);
	define("FIELD",3);
	define("CARD_IMAGE",4);
	define("TEXT",5);
	define("HORIZONTAL_LINE",6);
	define("LINEBREAK",7);
	define("FORMTEXT",8);
	define("PAYLINK",9);
	
	//Definition of payment state on registrations.
	define("UNPAID", 1);
	define("PAID_BY_CARD", 2);
	define("PAID_BY_INVOICE", 3);
	define("REMINDER_SENT", 4);
	define("SUSPICIOUS", 5);
	
	//---------------------------------------------------------------------------------------------------------------
	// err - Displays nicely formatted error and exits
	//---------------------------------------------------------------------------------------------------------------
	
	function err ($errmsg,$hdr='') {
		if (!empty($hdr)) {
				echo($hdr);
		}
		print "<p><span class=\"err\">Serious Error: <br /><i>$errmsg</i>.";
		print "</span></p>\n";
		exit;
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// err - Makes database connection
	//---------------------------------------------------------------------------------------------------------------
	
	function dbConnect() {
		$printHeaderFunction=0;
		// Send header info to err()?
		if ($printHeaderFunction) {
			$hdr = 'Database Connection Error';
		} else {
			$hdr = '';
		}
	
		// Connect to DB server
		$OC_db = mysql_connect(DB_HOST,DB_USER,DB_PASSWORD) or err("Could not connect to database ".mysql_errno(),$hdr);
		mysql_set_charset('utf8',$OC_db); 
		// Select DB
		mysql_select_db(DB_NAME) or err("Could not select database \"".DB_NAME."\" error code".mysql_errno(),$hdr);
		
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// getUniqueCode - Creates a unique code from random number and md5 hash and uses a maximum length
	//---------------------------------------------------------------------------------------------------------------
	function getUniqueCode($length = ""){
		$code = md5(uniqid(rand(), true));
		if ($length != "") return substr($code, 0, $length);
		else return $code;
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Generatesorter - Genreates a sorter heading for a table
	//---------------------------------------------------------------------------------------------------------------
	
	function generatesorter($sortorder,$sortkind,$name,$sorterstyle,$sorterstyleselected){
		echo "<a href='#'><td ";
		echo "onclick='document.".$name."Form.submit();' ";
		if($sortorder==$name){
				echo "id='selected' >";
			if($sortkind=="UP"){
				echo "<img src='ArrowUp.png' />";
			}else{
				echo "<img src='ArrowDown.png' />";			
			}
		}else{
			echo ">";	
		}
		echo $name;
		echo "</td></a>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Generatesorter - Genreates a sorting form for a table
	//---------------------------------------------------------------------------------------------------------------
	
	function generatesortform($sortname,$sortkind,$path){
		echo "<form action='".$path."' method='post' name='".$sortname."Form'>";
		echo "<input type='hidden' name='sortorder' value='".$sortname."' />";
	
		if($sortkind=='UP'){
			echo "<input type='hidden' name='sortkind' value='DOWN' />";
		}else{
			echo "<input type='hidden' name='sortkind' value='UP' />";		
		}
	
		passon("tabname","");
		passon("conferencefilter","");
		
		echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";
		echo "</form>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	//  - Specialty version of the function above not to generate errors.
	//---------------------------------------------------------------------------------------------------------------
	
	function generatesortformRegistrations($sortname,$sortkind,$path, $keywords, $filter){		
			
		echo "<form action='".$path."' method='post' name='".$sortname."Form'>";
		echo "<input type='hidden' name='sortorder' value='".$sortname."' />";
	
		if($sortkind=='UP'){
			echo "<input type='hidden' name='sortkind' value='DOWN' />";
		}else{
			echo "<input type='hidden' name='sortkind' value='UP' />";		
		}
	
		passon("tabname","");
		passon("conferencefilter","");
		if($keywords != false)
			passon("filterReg", $keywords);
		if($filter != false)
			passon("filterColumn", $filter);
		echo "<input class='hiddenCheckString' type='hidden' name='checkString' value='' />";
		echo "<input class='hiddenSuspiciousState' type='hidden' name='suspiciousState' value='' />";
		echo "</form>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// genereateButton - Generates various buttons.
	//---------------------------------------------------------------------------------------------------------------
	
	function generateButton($userkind, $state, $lineno, $type, $additionalcost, $conf, $reminderCard){
		if($userkind==ADMIN || $userkind==ORGANIZER) {
			if($state == UNPAID || $state == REMINDER_SENT) {
				if($type == 'invoice') {
					echo "<td class='h35'><input alt='#TB_inline?height=150&width=295&inlineId=markPaidConfirm_".$lineno."' title='Mark Paid by Invoice' class='thickbox' style=' font-size: 1.0em; margin:0;' type='button' value='Mark Paid by Invoice' id='button_$lineno'/></td>";
				}
				if($type == 'addCost') {
					echo "<td class='h35' id='td_AddCost_$lineno' NOWRAP><input name='costField' style='width: 70px; height: 20px; float: none; clear: both; margin: 0; display:inline;' class='textfield addCostInp' title='Rebates and costs. Takes both positive(+) and negative(-) values.' id='costField_$lineno'  type='text' value='".$additionalcost."' />";
					echo "&nbsp<input alt='#TB_inline?height=150&width=295&inlineId=addCostBox_".$lineno."' title='Additional Cost' class='thickbox' style=' font-size: 1.0em; padding: 5px 10px 4px; margin:0;' onclick='fixAddCostMessage(\"$lineno\");' type='button' value='Save' id='addCostButton_$lineno'/></td>";
				}
				if($type == 'susp') {
					echo "<td class='h35'><input style='font-size: 1.0em; margin:0;' type='button' onclick='markSuspicious(\"$lineno\", \"$conf\", 1);' value='Mark Suspicious' id='suspButton_$lineno'/></td>";
				}
			}
			else {
				if($type == 'invoice') {
					echo "<td class='h35'><input alt='#TB_inline?height=150&width=295&inlineId=markPaidConfirm_".$lineno."' title='Mark Paid by Invoice' class='thickbox' style='cursor:default; font-size: 1.0em; margin:0;' type='button' value='Mark Paid by Invoice' id='button_$lineno' disabled='disabled' /></td>";
				}
				if($type == 'addCost') {
					echo "<td class='h35' id='td_AddCost_$lineno'>$additionalcost</td>";	
				}
				if($type == 'susp') {
					if($state == SUSPICIOUS)
						echo "<td class='h35'><input style='font-size: 1.0em; margin:0;' type='button' onclick='markSuspicious(\"$lineno\", \"$conf\", 0);' value='Mark Unsuspicious' id='suspButton_$lineno'/></td>";
					elseif($state == UNPAID || $state == REMINDER_SENT)
						echo "<td class='h35'><input style='font-size: 1.0em; margin:0;' type='button' value='Mark Suspicious' id='suspButton_$lineno' onclick='markSuspicious(\"$lineno\", \"$conf\", 1);' id='suspButton_$lineno' /></td>";	
					else
						echo "<td class='h35' style='cursor:default' ><input  style='cursor:default; font-size: 1.0em; margin:0;' type='button' value='Mark Suspicious' disabled='disabled' id='suspButton_$lineno'/></td>";	
				}
			}
			if($type == 'reminder') {
				if($state == UNPAID || $state == SUSPICIOUS)  {
					if($reminderCard == true) {
						echo "<td class='h35'><input alt='#TB_inline?height=150&width=295&inlineId=sendReminder_".$lineno."' title='Send Reminder' class='thickbox' style='font-size: 1.0em; margin:0;' type='button' value='Send Reminder' id='sendReminderButton_$lineno' /></td>";
					}
					else {
						echo "<td class='h35'><input style='cursor:default; font-size: 1.0em; margin:0;' type='button' value='Send Reminder' title='No Reminder Card available for this conference' id='sendReminderButton_$lineno'  disabled='disabled'/></td>";
					}
				}
				else {
					echo "<td class='h35'><input alt='#TB_inline?height=150&width=295&inlineId=sendReminder_".$lineno."' title='Send Reminder' class='thickbox' style='cursor:default; font-size: 1.0em; margin:0;' type='button' value='Send Reminder' title='No need to send them' id='sendReminderButton_$lineno' disabled='disabled' /></td>";
				}
			}
		}
		else {
			if($type == 'addCost') {
				echo "<td class='h35' >$additionalcost</td>";	
			}
		}
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// generatePaidConfirmBox - Generates the confirm box and code for marking registrations as paid by invoice
	//---------------------------------------------------------------------------------------------------------------
	
	function generateConfirmBox($userkind, $state, $lineno, $conferencefilter) {
		if($userkind==ADMIN || $userkind==ORGANIZER) {
			if($state == UNPAID || $state == REMINDER_SENT || $state == SUSPICIOUS) {
				echo "<div style='display: none' id='markPaidConfirm_".$lineno."' class='markPaidConfirm'>";
				echo "<p class='removeConfirm'><strong>Are you sure you want the registration with the linenumber below to be registered as paid by Invoice?</strong></p>";
				echo "<div class='removeConfirm' style='float: left;'>Lineno:&nbsp;&nbsp;</div>";
				echo "<div class='removeConfirm'><span style='font-size: 1.5em'>".$lineno."</span></div>";
				echo "<div class='removeConfirm' id='removeConfirmButtonholder'>";
				echo "<input name='Button' type='button' value='Yes' class='button' onClick='markPaid(\"$lineno\", \"$conferencefilter\");' />&nbsp;&nbsp;";
				echo "<input name='Button' type='button' value='Cancel' class='button' onClick='tb_remove();' />";
				echo "</div>";
				echo "</div>";
				
				echo "<div style='display: none' id='addCostBox_".$lineno."' class='addCostConfirmBox'>";
				echo "<p class='removeConfirm' id='addCostMessage_".$lineno."'></p>";
				echo "<div id='costDiv_".$lineno."' class='removeConfirm' style='font-size: 3em; margin: 20px 0 20px 0; text-align: center;'>".$lineno."</div>";
				echo "<div class='removeConfirm' id='removeConfirmButtonholder'>";
				echo "<input name='Button' id='okButton_$lineno' type='button' value='Yes' class='button' onClick='addAdditional(\"$lineno\", \"$conferencefilter\");' />&nbsp;&nbsp;";
				echo "<input name='Button' type='button' value='Cancel' class='button' onClick='tb_remove();' />";
				echo "</div>";
				echo "</div>";
			}
			if($state == UNPAID || $state == SUSPICIOUS) {
				echo "<div style='display: none' id='sendReminder_".$lineno."' class='sendReminderBox'>";
				echo "<p class='removeConfirm'><span style='color:red'>Are you sure you want to send a payment reminder?</span></p>";
				echo "<div class='removeConfirm' id='removeConfirmButtonholder'>";
				echo "<input name='Button' id='okButton_$lineno' type='button' value='Yes' class='button' onClick='sendReminder(\"$lineno\", \"$conferencefilter\");' />&nbsp;&nbsp;";
				echo "<input name='Button' type='button' value='Cancel' class='button' onClick='tb_remove();' />";
				echo "</div>";
				echo "</div>";
			}
			
			
			echo "<div style='display: none' id='markSuspBox_".$lineno."' class='markSuspBox'>";
			echo "<p class='markSuspText'></p>";
			echo "<div class='removeConfirm' id='removeConfirmButtonholder'>";
			echo "<input name='Button' id='okButton_$lineno' type='button' value='Yes' class='button'";
			if($state == UNPAID || $state == REMINDER_SENT)
				echo "onClick='markSuspicious(\"$lineno\", \"$conferencefilter\", true);' />&nbsp;&nbsp;";
			else
				echo "onClick='markSuspicious(\"$lineno\", \"$conferencefilter\", false);' />&nbsp;&nbsp;";
			echo "<input name='Button' type='button' value='Cancel' class='button' onClick='tb_remove();' />";
			echo "</div>";
			echo "</div>";
		}
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// addsortorder - Adds sort order to SQL Query
	//---------------------------------------------------------------------------------------------------------------
	
	function addsortorder($querystring,$sortorder,$sortkind) {
		if($sortorder!="None"){
			$querystring.=" ORDER BY ".$sortorder." ";
			if($sortkind=="UP"){
				$querystring.="ASC";
			}else{
				$querystring.="DESC";					
			}
		}
		return $querystring;
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// loginform -  Makes a login form with a specified path.
	//---------------------------------------------------------------------------------------------------------------
	
	function loginform($path,$helptext,$boxtext) {
		echo "<div id='loginform'>";
		echo "<img src='Pernilla_Icon_192.png' /><br />";
		echo "<form name='form1' method='post' action='".$path."'>";
		echo "<h3>".$boxtext."</h3>";
		echo "<h4>Username</h4><input title='Your email address' name='myusername' type='text' id='myusername' class='textfield' />";
		echo "<h4>Password</h4><input title='Your password' name='mypassword' type='password' id='mypassword' class='textfield' /></td></tr>";
		echo "<input name='loginFail' type='hidden' id='loginFail' />";
		echo "<input type='submit' name='Submit' value='Login' class='button' />";
		echo "</form></div>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// passon - Passes a certain parameter onwards if it exists or if a value is given
	//---------------------------------------------------------------------------------------------------------------
	
	function passon($varname,$value) {
		if($value!=""){
			echo "<input type='hidden' name='".$varname."' value='".$value."' />";
		}else if(isset($_POST[$varname])){
			echo "<input type='hidden' name='".$varname."' value='".$_POST[$varname]."' />";
		}	
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// phpencode - Encodes a string to stop buffer errors and exploits includes quotes
	//---------------------------------------------------------------------------------------------------------------
	
	function phpencode($value,$limit) {
		// Limit under 0 i.e. -x means that it is a number of at most x
		if($limit<0){
			// Return quoted number
			if(is_numeric($value)){
				if($value>-$limit) $value=-$limit;
				return "'".$value."'";
			}else{
				return '0';
			}
		}else{
			// Otherwise return a quoted string
			return "'".substr(utf8tohtml(urldecode($value), true),0,$limit)."'";			
		}
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// menuheading - Generates a heading including a function selection form for each of the headings
	//---------------------------------------------------------------------------------------------------------------
	
	function menuheading($headingname,$tabstyle,$formname,$currenttab) {
		if($formname==$currenttab){
			echo "<li id='active' ";
		}else {
			echo "<li ";
		}
		echo "class='menuItem' onclick='document.".$formname."Form.submit();' ";
		echo "><a href='#'>";
		echo $headingname;
		echo "</a></li>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// menuheading - Generates a heading including a function selection form for each of the headings
	//---------------------------------------------------------------------------------------------------------------
	
	function generatetabform($path,$tabname){		
		echo "<form action='".$path."' method='post' name='".$tabname."Form'>";
		echo "<input type='hidden' name='tabname' value='".$tabname."' />";		
		passon("conferencefilter","");
		echo "</form>";
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Hopefully fixes encoding issues with ajax applications
	//---------------------------------------------------------------------------------------------------------------
	
	function utf8tohtml($utf8, $encodeTags) {
		$result = '';
		for ($i = 0; $i < strlen($utf8); $i++) {
			$char = $utf8[$i];
			$ascii = ord($char);
			if ($ascii < 128) {
				// one-byte character
				$result .= ($encodeTags) ? htmlentities($char, ENT_QUOTES, 'UTF-8') : $char;
			} else if ($ascii < 192) {
				// non-utf8 character or not a start byte
			} else if ($ascii < 224) {
				// two-byte character
				$result .= htmlentities(substr($utf8, $i, 2), ENT_QUOTES, 'UTF-8');
				$i++;
			} else if ($ascii < 240) {
				// three-byte character
				$ascii1 = ord($utf8[$i+1]);
				$ascii2 = ord($utf8[$i+2]);
				$unicode = (15 & $ascii) * 4096 +
						   (63 & $ascii1) * 64 +
						   (63 & $ascii2);
				$result .= "&#$unicode;";
				$i += 2;
			} else if ($ascii < 248) {
				// four-byte character
				$ascii1 = ord($utf8[$i+1]);
				$ascii2 = ord($utf8[$i+2]);
				$ascii3 = ord($utf8[$i+3]);
				$unicode = (15 & $ascii) * 262144 +
						   (63 & $ascii1) * 4096 +
						   (63 & $ascii2) * 64 +
						   (63 & $ascii3);
				$result .= "&#$unicode;";
				$i += 3;
			}
		}
		return $result;
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Used to gather conferences for a user based on user privileges 
	//---------------------------------------------------------------------------------------------------------------
	
	function gatherConferences($userId){
	    /* Deretmine user kind
		 * If admin get all conferences
		 * Else get conferences for that user
		 * Return array of confname or FALSE if no conferences found
		 */
		$userId = mysql_real_escape_string($userId);
		$conferences = array();
		$hasConferences = FALSE;
		$querystring="SELECT kind FROM personal WHERE PID='".$userId."';";
		$result=mysql_query($querystring);
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database UserID Check Error");
		$row = mysql_fetch_array($result);
		$userKind = $row['kind'];
		if($userKind==1){ // User is admin
			//Put all conferences in the database in the array
			$querystring = "SELECT confname FROM conferences";
			$result=mysql_query($querystring);
			if(mysql_num_rows($result) > 0){
				$hasConferences=TRUE;
				while($row = mysql_fetch_array($result)){
					$conferences[]=$row['confname'];
				}
			}
		} else { //User isn't admin
			//Get conferences string and explode string into array
			$querystring = "SELECT conferences FROM personal WHERE PID='".$userId."'";
			$result=mysql_query($querystring);
			$row = mysql_fetch_array($result);
			if(mysql_num_rows($result) > 0 and $row['conferences'] !=""){
				$conferences = explode(',',$row['conferences']);
				$hasConferences=TRUE;
			}
		}
		
		//echo "<p>gatherarr</p>";
		//print_r($conferences);
		
		if($hasConferences){	
			return $conferences;
		} else {
			return FALSE; //No conferences found for given user id
		}
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// sanitizeInput - Sanitizes the data before insering into the database
	//---------------------------------------------------------------------------------------------------------------
	
	function sanitizeInput($input) {
		if(get_magic_quotes_gpc()) {
			$input = stripslashes($input);
		}
		return mysql_real_escape_string($input);
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Generate Search String - Builds a search string for searching registations
	//---------------------------------------------------------------------------------------------------------------
	
	function genSearchStr($conferencefilter, $keywords, $filterReady, $suspState) {
		$keys = genKeywords($keywords, true); //prepare keywords
		$regularKeywords = $keys[0];
		$quotedKeywords = $keys[1];
		
		$result = mysql_query("SHOW COLUMNS FROM conf_".$conferencefilter.""); //Gets all columns
		if (!$result) err("SQL Query Error: ".mysql_error(),"Database Query Error");
		
		while($row = mysql_fetch_array($result)) {
			if(!($row[1] == "varchar(3)" || $row[1] == "int(11)")) { //Don't search yes/no and ints
				$columns[] = $row[0];
			}
		}
	
		foreach($regularKeywords as $term) { 
			foreach($columns as $column) { //Only search selected columns
				$clauses[] = $column." LIKE '%".$term."%'"; // Data is stored encoded so the search should be
			}
		}
		
		foreach($quotedKeywords as $term){   
			foreach($columns as $column) {
				$clauses[] = $column." = '".$term."'";
			}
		}
		
		if (!empty($clauses)) {   
			$filter='('.implode(' OR ', $clauses).')'; //Build the query string
			if($filterReady)
				$sql = " WHERE $filter";
			else
				$sql = "SELECT * FROM conf_$conferencefilter WHERE $filter";
			if($suspState != 1)
				$sql .= "AND state != 5";
		}
		else
			$sql = "SELECT * FROM conf_".$conferencefilter; //If nothing is found
		
		return $sql;
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Search One Column - Similar to gen search string but only applies to one column.
	//---------------------------------------------------------------------------------------------------------------
	
	function searchOneColumn($conferencefilter, $keywords, $filterReady, $column, $suspState) {
		$keys = genKeywords($keywords, true);
		$regularKeywords = $keys[0];
		$quotedKeywords =  $keys[1];
	
		foreach($regularKeywords as $term){ 
			$clauses[] = $column." LIKE '%".$term."%'";
		}
		
		foreach($quotedKeywords as $term){   
			$clauses[] = $column." = '".$term."'";
		}
		
		$filter='('.implode(' OR ', $clauses).')';
		
		if($filterReady)
			$sql =  " WHERE $filter";
		else
			$sql = "SELECT * FROM conf_$conferencefilter WHERE $filter";
		if($suspState != 1)
			$sql .= "AND state != 5";
		
		return $sql;
	
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Get Containing Columns - Searches the returned data and returns columns that contain the search term.
	//---------------------------------------------------------------------------------------------------------------
	
	function getContColumns($conferencefilter, $keywords, $allColumns, $filteredColumns) {
		$keys = genKeywords($keywords, false);
		$regularKeywords = $keys[0];
		$quotedKeywords =  $keys[1];
	
		$contains = array();
		$searchRes = mysql_query(genSearchStr($conferencefilter, $keywords, false, 0)); //Search db with keywords
		while($row = mysql_fetch_assoc($searchRes)) {
			foreach($regularKeywords as $term) {
				foreach($allColumns as $column) {
					if(strpos(strtolower($row[$column]), strtolower($term)) !== false) { //If the word is contained in the result
						$contains[] = $column;
					}
				}
			}
			foreach($quotedKeywords as $term) {
				foreach($allColumns as $column) {
					if(strpos(strtolower(" ".$row[$column]." "), strtolower(" ".$term." ")) !== false) { 
						$contains[] = $column;
					}
				}
			}
		}
		if(!empty($contains)) // Should always have at least one result cause otherwise the search gave nothing.
			return array_unique($contains);
	}
	
	//---------------------------------------------------------------------------------------------------------------
	// Generate keyword list - A help function for reusable code that creates list from keywords
	//---------------------------------------------------------------------------------------------------------------
	
	function genKeywords($keywords, $sanitize) {
		$regularKeywords = array();
		$quotedKeywords = array();
		$tempReg = array();
		$tempQuote = array();
		
		$regKeywords = preg_split('/"[^"]+"/', $keywords); //splits on quotes, to get regular words
		foreach($regKeywords as $key) {
			if(!empty($key)) {
				$key =  str_replace("'", "", $key); //Fixes single quotes
				$tempReg[] = trim($key, "\"\\"); //Trims trailing quotes like "xxx"
			}
			
		}
		
		preg_match_all('/"(.*?)"/', $keywords, $qResult); //Break out quoted "words"
		foreach(end($qResult) as $res) { //They always end up in the last element hence end()
			$tempQuote[] = $res;
		}
		
		foreach($tempReg as $term) {
			foreach(explode(" ", $term) as $subTerm) { //For words separated by space
				if(!empty($subTerm)) {
					if($sanitize == true)
						$subkey = sanitizeInput($subTerm); //Fix injections
					$regularKeywords[] = htmlentities($subTerm, ENT_QUOTES, 'UTF-8'); // Everything in db is encoded, hence search terms need to be.
				}
			}	
		}
		
		foreach($tempQuote as $term) {
			foreach(explode(" ", $term) as $subTerm) {
				if(!empty($subTerm)) {
					if($sanitize == true)
						$subkey = sanitizeInput($subTerm);
					$quotedKeywords[] = htmlentities($subTerm, ENT_QUOTES, 'UTF-8');
				}
			}	
		}
		return array($regularKeywords, $quotedKeywords);	
	}
	
	function checkTimes($confstart, $regstart, $regend){
		if($regend < $regstart){
			return false;
		}else{
			if($confstart < $regend){
				return false;
			}else {
				return true;
			}
		}
	}
	
	function checkMail($email){
		/*non-case sensitive email check.*/
		return eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email);
	}
?>
