<?PHP

// CONSTANTS //

// 1 - Heading
// 2 - Text input
// 3 - Text box
// 4 - Dropdown
// 41 - Dropdown option ??????
// 5 - Placeholder
// 6 - Radio button
// 7 - Checkbox
// 8 - Computation box
// 9 - HR
// 10 - Footnote
// 11 - Image

if (isset($_POST['data']))
{
	// AJAX CALL //
	/*include("dbcredentialspath.php");
	include(DB_CREDENTIALS_PATH);
	require_once('basic.php');
	dbConnect();*/
	
	if (isset($_POST['action'])) {
		$action = $_POST['action'];
	}
	
	if (isset($action) && strcmp($action, 'preview') == 0)
		echo doGenerate($_POST['data']);
}

// HELPER FUNCTIONS //
function getNodeInnerHTML(DOMNode $oNode)
{
	$oDom = new DOMDocument('1.0', 'utf-8');
	
	foreach($oNode->childNodes as $oChild)
	{
		$oDom->appendChild($oDom->importNode($oChild, true));
	}
	
	return $oDom->saveHTML();
}

function addField(&$arr, $value, $type)
{		
	$arr[] = array('value' => $value, 'type' => $type);
}

function sanitizeCost($cost)
{
	if (strlen($cost) == 0 || !is_numeric($cost) || (int)$cost < 0) $cost = 0;
	
	return $cost;
}

function sanitizeName($name)
{
	// TODO: Restrictions on what the name could be here. Escape unallowed characters and whatnot
	
	if (!isset($name) || strlen($name) == 0) $name = 'unnamed';
	$name = htmlentities($name);
	// TODO: Make name unique if not already
	
	return $name;
}

function utf8_urldecode($str) {
    $str = preg_replace("/%u([0-9a-f]{3,4})/i","&#x\\1;",urldecode($str));
    return html_entity_decode($str,null,'UTF-8');;
  }

// PARSE FORM //
function doGenerate($source, $saveFields = FALSE, $confName = '', $formName = '') // Confname & formname only needed if fields should be saved
{
	$output = '';
	$debug 	= '';
	$dbFields = array(); // Associative -> no mysql errors due to duplicate names
	
	$sourceDom = new DomDocument('1.0', 'utf-8');
	$sourceDom->preserveWhiteSpace = false;
	$sourceDom->loadHTML('<form>' . utf8_urldecode($source) . '</form>');
	
	$colors = array('#FFFFFF'); //'#E3B6C1', '#B6BEE3', '#B6E3B9');
	
	$xpath = new DOMXPath($sourceDom);
	
	/* GENERATE */
	
	$tableOpen 	= false;
	$tableEmpty = true;
	$sectionOpen = false;
	
	$rows = $xpath->query("//ul[@id='userform']/li");
	$textNodes = $xpath->query('//text()');
	//foreach ($textNodes as $node) echo $node->nodeValue;
	$firstOfGroupHelper = array();
	
	foreach($rows as $row)
	{
		$fields = $xpath->query("ul/li", $row);
		$rowClass = $row->attributes->getNamedItem('class')->value;
		if (preg_match('/field-heading/', $rowClass))
		{
			if ($tableOpen) 	$output .= '</table>';
			if ($sectionOpen) 	$output .= '</div>';
			
			$color = $colors[rand(0, count($colors) - 1)];
			$output .= '<div style="background-color: ' . $color . '">';
			$output .= htmlentities($sourceDom->saveXML($row->firstChild), ENT_COMPAT, 'utf-8', false);
			
			$output .= '<table>';
			
			$tableOpen 	= true;
			$tableEmpty = true;
			$sectionOpen = true;
		}
		else if (preg_match('/field-footnote/', $rowClass))
		{
			if ($tableOpen) {
				$output .= '</table>';
				$tableOpen 	= false;
			}
			
			$output .= '<table><tr><td>';
			$output .= htmlentities($sourceDom->saveXML($row->firstChild), ENT_COMPAT, 'utf-8', false);
			$output .= '</td></tr></table>';
				
		}
		else if ($fields->length == 0)
		{
			if (!$tableEmpty) // Ignore repeated empty rows
			{				
				if ($tableOpen) $output .= '</table>';
			
				$output .= '<br />';
				$output .= '<table>';
				
				$tableOpen 	= true;
				$tableEmpty = true;
			}
		}
		else
		{
			$output .= '<tr>';
			$tableEmpty = false;
			
			foreach ($fields as $field)
			{
				$class 	= $field->attributes->getNamedItem('class')->value;
				$texts 	= $xpath->query('.//text()', $field);
				foreach ($texts as $node) {
					$newString = htmlentities($node->nodeValue, ENT_COMPAT, 'UTF-8', false);
					$node->deleteData(0, 9999);
					$node->insertData(0, $newString);
				}
				$output .= '<td>';
				
				if (preg_match('/field-textinput/', $class))
				{
					$input = $field->getElementsByTagName('input')->item(0);
					$label = $field->getElementsByTagName('span')->item(0)->nodeValue;
					
					$name = sanitizeName($input->getAttribute('data-name'));
					
					$dbFields[$name] = array('fieldText' => $label, 'type' => 2, 'cost' => NULL, 'group' => NULL);
					
					$input->setAttribute('name', $name);					
					$input->removeAttribute('readonly');
					$output .= getNodeInnerHTML($field);
				}
				else if (preg_match('/field-dropdown/', $class))
				{
					$select = $field->getElementsByTagName('select')->item(0);
					$name = sanitizeName($select->getAttribute('data-name'));
					$label = $field->getElementsByTagName('span')->item(0)->nodeValue;
					
					$options = $select->getElementsByTagName('option');
					foreach	($options as $option) {
						$optionName = sanitizeName($option->nodeValue);
						$cost 		= sanitizeCost($option->getAttribute('data-cost'));
						$dbFields[$optionName] = array('fieldText' => $label, 'type' => 4, 'cost' => $cost, 'group' => $name);
						
						$option->setAttribute('value', $optionName);
					}
					
					$select->setAttribute('name', $name);
					$output .= getNodeInnerHTML($field);
				}
				else if (preg_match('/field-radio/', $class))
				{
					//$select->removeAttribute('readonly');
					$element= $field->getElementsByTagName('input')->item(0);
					$name 	= sanitizeName($element->getAttribute('data-name'));
					$cost 	= sanitizeCost($element->getAttribute('data-cost'));
					$group	= sanitizeName($element->getAttribute('name'));
					$label 	= $field->getElementsByTagName('span')->item(0)->nodeValue;
					
					$dbFields[$name] = array('fieldText' => $label, 'type' => 6, 'cost' => $cost, 'group' => $group);
					
					$element->setAttribute('name', $group);
					$element->setAttribute('value', $name);
					$element->setAttribute('data-cost', $cost); 
					$element->setAttribute('data-cost', $cost);
					if (!isset($firstOfGroupHelper[$group])) {
						$element->setAttribute('checked', 'checked');
						$firstOfGroupHelper[$group] = true;
					}
					$output .= getNodeInnerHTML($field);
				}
				else if (preg_match('/field-checkbox/', $class))
				{
					$element = $field->getElementsByTagName('input')->item(0);
					
					$name = sanitizeName($element->getAttribute('data-name'));
					$cost = sanitizeCost($element->getAttribute('data-cost'));
					$label 	= $field->getElementsByTagName('span')->item(0)->nodeValue;
					
					$dbFields[$name] = array('fieldText' => $label, 'type' => 7, 'cost' => $cost, 'group' => NULL);
					
					$element->setAttribute('name', $name);
					$output .= getNodeInnerHTML($field);
				}
				else 
					$output .= getNodeInnerHTML($field); //Default behaviour
				
				$output .= '</td>';
			}
			
			$output .= '</tr>';
		}
	}
	
	if ($tableOpen)		$output .= '</table>';
	if ($sectionOpen) 	$output .= '</div>';
	
	// REMOVE EMPTY TABLES //
	
	$sourceDom = new DomDocument('1.0', 'utf-8');
	$sourceDom->preserveWhiteSpace = false;
	$sourceDom->loadHTML($output);
	
	$xpath = new DOMXPath($sourceDom);
	
	$tables = $xpath->query('//table');
	
	foreach ($tables as $table)
	{
		if (!$table->hasChildNodes())
		{
			$table->parentNode->removeChild($table);
		}
	}
	
	/* OUTPUT */
	
	$innerHTML = '';
	foreach ($sourceDom->getElementsByTagName('body')->item(0)->childNodes as $child)
	{
		$innerHTML .= $sourceDom->saveXML($child);
	}
	 /* SAVE FIELDS TO DATABASE*/
	if ($saveFields && count($dbFields) > 0)
	{
		$sql = "INSERT INTO fieldsNew (fieldname, conferenceId, formId, fieldtext, fieldtype, cost, groupName) VALUES ";
		$first = true;
		
		foreach ($dbFields as $name => $dbField) {
			
			if (!$first)
				$sql .= ', ';
			else 
				$first = false;
			
			$type = $dbField['type'];
			$cost = is_null($dbField['cost']) ? mysql_escape_string("NULL") : $dbField['cost'];
			$fieldtext = html_entity_decode($dbField['fieldText']);
			$name = html_entity_decode($name);
			
			$sql .= "('$name', '$confName', '$formName', '$fieldtext', $type, $cost, ";
			$sql .= (is_null($dbField['group']) ? 'NULL' : "'$dbField[group]'");
			$sql .=  ")";
		}
		
		if (!mysql_query("DELETE FROM fieldsNew WHERE conferenceId = '$confName' AND formId = '$formName'") ||
			!mysql_query($sql))
		{
			echo mysql_error();
		}
	}
	
	return html_entity_decode($innerHTML);
}

?>